/*
   This file shows the "basic model" that will be used in the
   following example programs.
*/

#if defined _WIN32 || defined _WIN64
#  include <windows.h>
#endif

#ifdef __APPLE__
#  include <GLUT/glut.h>
#else
#  include <GL/glut.h>
#endif


/* Prototype for the display callback function */
void display( void );


int main(int argc, char** argv)
{
   /* Standard GLUT initialization */
   glutInit(&argc,argv);
   glutInitDisplayMode (GLUT_SINGLE | GLUT_RGB); /* default, not needed */
   glutInitWindowSize(500,500);    /* 500 x 500 pixel window */
   glutInitWindowPosition(50,50);  /* place window near top left of display */
   glutCreateWindow("Basic Model");/* window title */
   glutDisplayFunc(display);       /* display callback invoked when window opened */

   /* Initialize OpenGL state */
   glClearColor(1.0, 1.0, 1.0, 1.0); /* white background */
   /* set up viewing */
   glMatrixMode(GL_PROJECTION);
   glLoadIdentity();
   gluOrtho2D(-10.0, 10.0, -10.0, 10.0); /* viewing volume */

   /* Enter event loop */
   glutMainLoop();

   return 0;  /* we never get here */
}//main()


/* This function sends one instance of our model down the graphics pipeline. */
void model( void )
{
   /* Here are the primitives that make up our basic model. */
   glBegin(GL_LINE_LOOP);
      glVertex2f( 1.0,  1.0);  // a square
      glVertex2f(-1.0,  1.0);
      glVertex2f(-1.0, -1.0);
      glVertex2f( 1.0, -1.0);
   glEnd();
   glBegin(GL_LINE_LOOP);
      glVertex2f( 2.0,  2.0);  // another square
      glVertex2f(-2.0,  2.0);
      glVertex2f(-2.0, -2.0);
      glVertex2f( 2.0, -2.0);
   glEnd();
   glBegin(GL_LINES);
      glVertex2f( 1.0,  1.0);  // two line segments
      glVertex2f( 2.0,  2.0);
      glVertex2f(-2.0,  1.0);
      glVertex2f( 1.0, -2.0);
   glEnd();
}//model()

/* The display() callback function */
void display( void )
{
   glClear(GL_COLOR_BUFFER_BIT); /* clear the window */

   glMatrixMode(GL_MODELVIEW);
   glLoadIdentity();

   glColor3f(1.0, 0.0, 0.0);     /* draw in red */

   model();                      /* draw our basic model */

   glFlush(); /* clear buffers */

}//display()