/*


*/

#include <stdio.h>

#if defined _WIN32 || defined _WIN64
#  include <windows.h>
#endif

#ifdef __APPLE__
#  include <GLUT/glut.h>
#else
#  include <GL/glut.h>
#endif

int windowHeight;         // this is set by the glut reshape() callback function
int windowWidth;          // this is set by the glut reshape() callback function

/* Prototypes for the GLUT callback functions */
void display( void );
//void reshape(int, int);

int main(int argc, char** argv)
{
   /* Standard GLUT initialization */
   glutInit(&argc,argv);
   glutInitDisplayMode (GLUT_SINGLE | GLUT_RGB); 
   glutInitWindowSize(600,600);    /* 600 x 600 pixel window */
   glutInitWindowPosition(50,50);  /* place window near top left of display */
   glutCreateWindow(argv[0]);      /* window title */
   glutDisplayFunc(display);
   //glutReshapeFunc(reshape);

   /* Initialize OpenGL state */
   /* attributes */
   glClearColor(1.0, 1.0, 1.0, 1.0); /* white background */
   /* set up viewing */
   glMatrixMode(GL_PROJECTION);
   glLoadIdentity();
   gluOrtho2D(-5.0, 5.0, -5.0, 5.0); /* viewing volume */

   /* Enter event loop */
   glutMainLoop();

   return 0;  /* we never get here */
}//main()


/* The display() callback function */
void display( void )
{
   glClear(GL_COLOR_BUFFER_BIT); /* clear the window */
   
   glMatrixMode(GL_MODELVIEW);
   glLoadIdentity();

   // draw the x-axis and y-axis
   glColor3f(0.0, 0.0, 1.0);     /* draw in blue */   
   glBegin(GL_LINES);
      glVertex2f(-5.0,  0.0);
      glVertex2f( 5.0,  0.0);
      glVertex2f( 0.0, -5.0);
      glVertex2f( 0.0,  5.0);
   glEnd();
   
   glColor3f(1.0, 0.0, 0.0);     /* draw in red */   
   /* Try many different combinations and orderings of translation, rotation, and scaling. */
 //glTranslatef(1.0, 0.0, 0.0);
 //glScalef(2.0, 2.0, 1.0);  
 //glRotatef(45.0, 0.0, 0.0, 1.0);

   glBegin(GL_LINE_LOOP);
      glVertex2f(-1.0, -1.0);
      glVertex2f(-1.0,  1.0);
      glVertex2f( 1.0,  1.0);
      glVertex2f( 1.0, -1.0);
   glEnd();

   glFlush(); /* clear buffers */
}//display()



/* The reshape() callback function */
void reshape(int width, int height)
{
   windowWidth  = width;
   windowHeight = height;

   printf("We got a \"reshape(%d, %d)\" event\n", width, height);

   display();
}//reshape()