/*

*/
#include <math.h>

#if defined _WIN32 || defined _WIN64
#  include <windows.h>
#endif

#ifdef __APPLE__
#  include <GLUT/glut.h>
#else
#  include <GL/glut.h>
#endif

/* Prototype for the display callback function */
void display( void );

#define PI 3.14159265

int main(int argc, char** argv)
{
   glutInit(&argc, argv);
   glutInitDisplayMode (GLUT_SINGLE | GLUT_RGB);
   glutInitWindowSize (500, 500);
   glutInitWindowPosition (100, 100);
   glutCreateWindow (argv[0]);
   glutDisplayFunc(display);

   /* Initialize OpenGL state */
   /* attributes */
   glClearColor(1.0, 1.0, 1.0, 1.0); /* white background */
   /* set up viewing */
   glMatrixMode(GL_PROJECTION);
   glLoadIdentity();
   gluOrtho2D(-4.0, 4.0, -4.0, 4.0); /* viewing volume */

   /* Enter event loop */
   glutMainLoop();

   return 0;  /* we never get here */
}

void circle()
{
   int n;
   glBegin(GL_LINE_LOOP);
     for (n = 0; n <= 100; n++)
        glVertex2f(cos((n/(double)100)*2*PI), sin((n/(double)100)*2*PI));
   glEnd();
   glBegin(GL_LINES);
     glVertex2f(-1.5,  0.0);
     glVertex2f( 1.5,  0.0);
     glVertex2f( 0.0, -1.5);
     glVertex2f( 0.0,  1.5);
   glEnd();
}

void display(void)
{
   int i;

   glClear(GL_COLOR_BUFFER_BIT);

   glMatrixMode(GL_MODELVIEW);
   glLoadIdentity();

   // Draw a small coordinate grid.
   glColor3f(0.7, 0.7, 0.7);  // Draw in light gray.
   glBegin(GL_LINES);         // Draw a set of grid lines
     for (i = -4; i <= 4; i++)
     {
        glVertex2f(-4.0,    i);
        glVertex2f( 4.0,    i);
        glVertex2f(   i, -4.0);
        glVertex2f(   i,  4.0);
     }
   glEnd();
   glColor3f(0.0, 0.0, 0.0);  // Draw in black.
   glBegin(GL_LINES);            // Draw a set of axes.
      glVertex2f(-4.0,  0.0);
      glVertex2f( 4.0,  0.0);
      glVertex2f( 0.0, -4.0);
      glVertex2f( 0.0,  4.0);
   glEnd();
   glColor3f(1.0, 0.0, 0.0);         /* draw in red */

   glPushMatrix();
     glTranslatef(2.0, 0.0, 0.0);    // rotate about (2,0)
     glRotatef(-45, 0.0, 0.0, 1.0);
     glTranslatef(-2.0, 0.0, 0.0);

     glScalef(0.25, 0.25, 1.0);
     circle();
   glPopMatrix();

   glPushMatrix();
     glTranslatef(0.0, -1.0, 0.0);    // rotate about (0,-1)
     glRotatef(-45, 0.0, 0.0, 1.0);
     glTranslatef(0.0, 1.0, 0.0);

     glScalef(0.25, 0.25, 1.0);
     circle();
   glPopMatrix();

   glFlush(); /* clear buffers */
}
